hw/usb/uhci: Declare QOM macros using OBJECT_DECLARE_TYPE()
[qemu/armbru.git] / configure
blobdccb5d4f96c33bed54789a207f2770b3527eae94
1 #!/bin/sh
3 # qemu configure script (c) 2003 Fabrice Bellard
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does.
8 CLICOLOR_FORCE= GREP_OPTIONS=
9 unset CLICOLOR_FORCE GREP_OPTIONS
11 # Don't allow CCACHE, if present, to use cached results of compile tests!
12 export CCACHE_RECACHE=yes
14 # make source path absolute
15 source_path=$(cd "$(dirname -- "$0")"; pwd)
17 if test "$PWD" = "$source_path"
18 then
19 echo "Using './build' as the directory for build output"
21 MARKER=build/auto-created-by-configure
23 if test -e build
24 then
25 if test -f $MARKER
26 then
27 rm -rf build
28 else
29 echo "ERROR: ./build dir already exists and was not previously created by configure"
30 exit 1
34 if ! mkdir build || ! touch $MARKER
35 then
36 echo "ERROR: Could not create ./build directory. Check the permissions on"
37 echo "your source directory, or try doing an out-of-tree build."
38 exit 1
41 cat > GNUmakefile <<'EOF'
42 # This file is auto-generated by configure to support in-source tree
43 # 'make' command invocation
45 ifeq ($(MAKECMDGOALS),)
46 recurse: all
47 endif
49 .NOTPARALLEL: %
50 %: force
51 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
52 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
53 @if test "$(MAKECMDGOALS)" = "distclean" && \
54 test -e build/auto-created-by-configure ; \
55 then \
56 rm -rf build GNUmakefile ; \
58 force: ;
59 .PHONY: force
60 GNUmakefile: ;
62 EOF
63 cd build
64 exec "$source_path/configure" "$@"
67 # Temporary directory used for files created while
68 # configure runs. Since it is in the build directory
69 # we can safely blow away any previous version of it
70 # (and we need not jump through hoops to try to delete
71 # it when configure exits.)
72 TMPDIR1="config-temp"
73 rm -rf "${TMPDIR1}"
74 if ! mkdir -p "${TMPDIR1}"; then
75 echo "ERROR: failed to create temporary directory"
76 exit 1
79 TMPB="qemu-conf"
80 TMPC="${TMPDIR1}/${TMPB}.c"
81 TMPO="${TMPDIR1}/${TMPB}.o"
82 TMPM="${TMPDIR1}/${TMPB}.m"
83 TMPE="${TMPDIR1}/${TMPB}.exe"
85 rm -f config.log
87 # Print a helpful header at the top of config.log
88 echo "# QEMU configure log $(date)" >> config.log
89 printf "# Configured with:" >> config.log
90 # repeat the invocation to log and stdout for CI
91 invoke=$(printf " '%s'" "$0" "$@")
92 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
93 { echo "$invoke"; echo; echo "#"; } >> config.log
95 quote_sh() {
96 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
99 print_error() {
100 (echo
101 echo "ERROR: $1"
102 while test -n "$2"; do
103 echo " $2"
104 shift
105 done
106 echo) >&2
109 error_exit() {
110 print_error "$@"
111 exit 1
114 do_compiler() {
115 # Run the compiler, capturing its output to the log. First argument
116 # is compiler binary to execute.
117 compiler="$1"
118 shift
119 if test -n "$BASH_VERSION"; then eval '
120 echo >>config.log "
121 funcs: ${FUNCNAME[*]}
122 lines: ${BASH_LINENO[*]}"
123 '; fi
124 echo $compiler "$@" >> config.log
125 $compiler "$@" >> config.log 2>&1 || return $?
128 do_compiler_werror() {
129 # Run the compiler, capturing its output to the log. First argument
130 # is compiler binary to execute.
131 compiler="$1"
132 shift
133 if test -n "$BASH_VERSION"; then eval '
134 echo >>config.log "
135 funcs: ${FUNCNAME[*]}
136 lines: ${BASH_LINENO[*]}"
137 '; fi
138 echo $compiler "$@" >> config.log
139 $compiler "$@" >> config.log 2>&1 || return $?
140 # Test passed. If this is an --enable-werror build, rerun
141 # the test with -Werror and bail out if it fails. This
142 # makes warning-generating-errors in configure test code
143 # obvious to developers.
144 if test "$werror" != "yes"; then
145 return 0
147 # Don't bother rerunning the compile if we were already using -Werror
148 case "$*" in
149 *-Werror*)
150 return 0
152 esac
153 echo $compiler -Werror "$@" >> config.log
154 $compiler -Werror "$@" >> config.log 2>&1 && return $?
155 error_exit "configure test passed without -Werror but failed with -Werror." \
156 "This is probably a bug in the configure script. The failing command" \
157 "will be at the bottom of config.log." \
158 "You can run configure with --disable-werror to bypass this check."
161 do_cc() {
162 do_compiler_werror "$cc" $CPU_CFLAGS "$@"
165 do_objc() {
166 do_compiler_werror "$objcc" $CPU_CFLAGS "$@"
169 # Append $2 to the variable named $1, with space separation
170 add_to() {
171 eval $1=\${$1:+\"\$$1 \"}\$2
174 compile_object() {
175 local_cflags="$1"
176 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -c -o $TMPO $TMPC
179 compile_prog() {
180 local_cflags="$1"
181 local_ldflags="$2"
182 do_cc $CFLAGS $EXTRA_CFLAGS $CONFIGURE_CFLAGS $QEMU_CFLAGS $local_cflags -o $TMPE $TMPC \
183 $LDFLAGS $EXTRA_LDFLAGS $CONFIGURE_LDFLAGS $QEMU_LDFLAGS $local_ldflags
186 # symbolically link $1 to $2. Portable version of "ln -sf".
187 symlink() {
188 rm -rf "$2"
189 mkdir -p "$(dirname "$2")"
190 ln -s "$1" "$2"
193 # check whether a command is available to this shell (may be either an
194 # executable or a builtin)
195 has() {
196 type "$1" >/dev/null 2>&1
199 version_ge () {
200 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
201 local_ver2=$(echo "$2" | tr . ' ')
202 while true; do
203 set x $local_ver1
204 local_first=${2-0}
205 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
206 shift ${2:+2}
207 local_ver1=$*
208 set x $local_ver2
209 # the second argument finished, the first must be greater or equal
210 test $# = 1 && return 0
211 test $local_first -lt $2 && return 1
212 test $local_first -gt $2 && return 0
213 shift ${2:+2}
214 local_ver2=$*
215 done
218 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
219 then
220 error_exit "main directory cannot contain spaces nor colons"
223 # default parameters
224 cpu=""
225 static="no"
226 cross_compile="no"
227 cross_prefix=""
228 host_cc="cc"
229 stack_protector=""
230 safe_stack=""
231 use_containers="yes"
232 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
234 if test -e "$source_path/.git"
235 then
236 git_submodules_action="update"
237 else
238 git_submodules_action="ignore"
241 git_submodules="ui/keycodemapdb"
242 git="git"
244 # Don't accept a target_list environment variable.
245 unset target_list
246 unset target_list_exclude
248 # Default value for a variable defining feature "foo".
249 # * foo="no" feature will only be used if --enable-foo arg is given
250 # * foo="" feature will be searched for, and if found, will be used
251 # unless --disable-foo is given
252 # * foo="yes" this value will only be set by --enable-foo flag.
253 # feature will searched for,
254 # if not found, configure exits with error
256 # Always add --enable-foo and --disable-foo command line args.
257 # Distributions want to ensure that several features are compiled in, and it
258 # is impossible without a --enable-foo that exits if a feature is not found.
260 default_feature=""
261 # parse CC options second
262 for opt do
263 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
264 case "$opt" in
265 --without-default-features)
266 default_feature="no"
268 esac
269 done
271 EXTRA_CFLAGS=""
272 EXTRA_CXXFLAGS=""
273 EXTRA_OBJCFLAGS=""
274 EXTRA_LDFLAGS=""
276 debug_tcg="no"
277 sanitizers="no"
278 tsan="no"
279 fortify_source="yes"
280 EXESUF=""
281 modules="no"
282 prefix="/usr/local"
283 qemu_suffix="qemu"
284 softmmu="yes"
285 linux_user=""
286 bsd_user=""
287 pie=""
288 coroutine=""
289 plugins="$default_feature"
290 meson=""
291 ninja=""
292 bindir="bin"
293 skip_meson=no
294 vfio_user_server="disabled"
296 # The following Meson options are handled manually (still they
297 # are included in the automatically generated help message)
299 # 1. Track which submodules are needed
300 fdt="auto"
302 # 2. Automatically enable/disable other options
303 tcg="auto"
304 cfi="false"
306 # parse CC options second
307 for opt do
308 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
309 case "$opt" in
310 --cross-prefix=*) cross_prefix="$optarg"
311 cross_compile="yes"
313 --cc=*) CC="$optarg"
315 --cxx=*) CXX="$optarg"
317 --cpu=*) cpu="$optarg"
319 --extra-cflags=*)
320 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
321 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
322 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
324 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
326 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
328 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
330 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
332 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
333 eval "cross_cc_cflags_${cc_arch}=\$optarg"
335 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
336 eval "cross_cc_${cc_arch}=\$optarg"
338 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
340 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
341 eval "cross_prefix_${cc_arch}=\$optarg"
343 esac
344 done
346 # Preferred compiler:
347 # ${CC} (if set)
348 # ${cross_prefix}gcc (if cross-prefix specified)
349 # system compiler
350 if test -z "${CC}${cross_prefix}"; then
351 cc="$host_cc"
352 else
353 cc="${CC-${cross_prefix}gcc}"
356 if test -z "${CXX}${cross_prefix}"; then
357 cxx="c++"
358 else
359 cxx="${CXX-${cross_prefix}g++}"
362 ar="${AR-${cross_prefix}ar}"
363 as="${AS-${cross_prefix}as}"
364 ccas="${CCAS-$cc}"
365 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
366 ld="${LD-${cross_prefix}ld}"
367 ranlib="${RANLIB-${cross_prefix}ranlib}"
368 nm="${NM-${cross_prefix}nm}"
369 smbd="$SMBD"
370 strip="${STRIP-${cross_prefix}strip}"
371 widl="${WIDL-${cross_prefix}widl}"
372 windres="${WINDRES-${cross_prefix}windres}"
373 windmc="${WINDMC-${cross_prefix}windmc}"
374 pkg_config_exe="${PKG_CONFIG-${cross_prefix}pkg-config}"
375 query_pkg_config() {
376 "${pkg_config_exe}" ${QEMU_PKG_CONFIG_FLAGS} "$@"
378 pkg_config=query_pkg_config
379 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
381 # default flags for all hosts
382 # We use -fwrapv to tell the compiler that we require a C dialect where
383 # left shift of signed integers is well defined and has the expected
384 # 2s-complement style results. (Both clang and gcc agree that it
385 # provides these semantics.)
386 QEMU_CFLAGS="-fno-strict-aliasing -fno-common -fwrapv"
387 QEMU_CFLAGS="-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE $QEMU_CFLAGS"
389 QEMU_LDFLAGS=
391 # Flags that are needed during configure but later taken care of by Meson
392 CONFIGURE_CFLAGS="-std=gnu11 -Wall"
393 CONFIGURE_LDFLAGS=
396 check_define() {
397 cat > $TMPC <<EOF
398 #if !defined($1)
399 #error $1 not defined
400 #endif
401 int main(void) { return 0; }
403 compile_object
406 check_include() {
407 cat > $TMPC <<EOF
408 #include <$1>
409 int main(void) { return 0; }
411 compile_object
414 write_c_skeleton() {
415 cat > $TMPC <<EOF
416 int main(void) { return 0; }
420 if check_define __linux__ ; then
421 targetos=linux
422 elif check_define _WIN32 ; then
423 targetos=windows
424 elif check_define __OpenBSD__ ; then
425 targetos=openbsd
426 elif check_define __sun__ ; then
427 targetos=sunos
428 elif check_define __HAIKU__ ; then
429 targetos=haiku
430 elif check_define __FreeBSD__ ; then
431 targetos=freebsd
432 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
433 targetos=gnu/kfreebsd
434 elif check_define __DragonFly__ ; then
435 targetos=dragonfly
436 elif check_define __NetBSD__; then
437 targetos=netbsd
438 elif check_define __APPLE__; then
439 targetos=darwin
440 else
441 # This is a fatal error, but don't report it yet, because we
442 # might be going to just print the --help text, or it might
443 # be the result of a missing compiler.
444 targetos=bogus
447 # OS specific
449 mingw32="no"
450 bsd="no"
451 linux="no"
452 solaris="no"
453 case $targetos in
454 windows)
455 mingw32="yes"
456 plugins="no"
457 pie="no"
459 gnu/kfreebsd)
460 bsd="yes"
462 freebsd)
463 bsd="yes"
464 make="${MAKE-gmake}"
465 # needed for kinfo_getvmmap(3) in libutil.h
467 dragonfly)
468 bsd="yes"
469 make="${MAKE-gmake}"
471 netbsd)
472 bsd="yes"
473 make="${MAKE-gmake}"
475 openbsd)
476 bsd="yes"
477 make="${MAKE-gmake}"
479 darwin)
480 bsd="yes"
481 darwin="yes"
482 # Disable attempts to use ObjectiveC features in os/object.h since they
483 # won't work when we're compiling with gcc as a C compiler.
484 QEMU_CFLAGS="-DOS_OBJECT_USE_OBJC=0 $QEMU_CFLAGS"
486 sunos)
487 solaris="yes"
488 make="${MAKE-gmake}"
489 # needed for CMSG_ macros in sys/socket.h
490 QEMU_CFLAGS="-D_XOPEN_SOURCE=600 $QEMU_CFLAGS"
491 # needed for TIOCWIN* defines in termios.h
492 QEMU_CFLAGS="-D__EXTENSIONS__ $QEMU_CFLAGS"
494 haiku)
495 pie="no"
496 QEMU_CFLAGS="-DB_USE_POSITIVE_POSIX_ERRORS -D_BSD_SOURCE -fPIC $QEMU_CFLAGS"
498 linux)
499 linux="yes"
501 esac
503 if test ! -z "$cpu" ; then
504 # command line argument
506 elif check_define __i386__ ; then
507 cpu="i386"
508 elif check_define __x86_64__ ; then
509 if check_define __ILP32__ ; then
510 cpu="x32"
511 else
512 cpu="x86_64"
514 elif check_define __sparc__ ; then
515 if check_define __arch64__ ; then
516 cpu="sparc64"
517 else
518 cpu="sparc"
520 elif check_define _ARCH_PPC ; then
521 if check_define _ARCH_PPC64 ; then
522 if check_define _LITTLE_ENDIAN ; then
523 cpu="ppc64le"
524 else
525 cpu="ppc64"
527 else
528 cpu="ppc"
530 elif check_define __mips__ ; then
531 cpu="mips"
532 elif check_define __s390__ ; then
533 if check_define __s390x__ ; then
534 cpu="s390x"
535 else
536 cpu="s390"
538 elif check_define __riscv ; then
539 cpu="riscv"
540 elif check_define __arm__ ; then
541 cpu="arm"
542 elif check_define __aarch64__ ; then
543 cpu="aarch64"
544 elif check_define __loongarch64 ; then
545 cpu="loongarch64"
546 else
547 # Using uname is really broken, but it is just a fallback for architectures
548 # that are going to use TCI anyway
549 cpu=$(uname -m)
550 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
553 # Normalise host CPU name and set multilib cflags. The canonicalization
554 # isn't really necessary, because the architectures that we check for
555 # should not hit the 'uname -m' case, but better safe than sorry.
556 # Note that this case should only have supported host CPUs, not guests.
557 case "$cpu" in
558 armv*b|armv*l|arm)
559 cpu="arm" ;;
561 i386|i486|i586|i686)
562 cpu="i386"
563 CPU_CFLAGS="-m32" ;;
564 x32)
565 cpu="x86_64"
566 CPU_CFLAGS="-mx32" ;;
567 x86_64|amd64)
568 cpu="x86_64"
569 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
570 # If we truly care, we should simply detect this case at
571 # runtime and generate the fallback to serial emulation.
572 CPU_CFLAGS="-m64 -mcx16" ;;
574 mips*)
575 cpu="mips" ;;
577 ppc)
578 CPU_CFLAGS="-m32" ;;
579 ppc64)
580 CPU_CFLAGS="-m64 -mbig-endian" ;;
581 ppc64le)
582 cpu="ppc64"
583 CPU_CFLAGS="-m64 -mlittle-endian" ;;
585 s390)
586 CPU_CFLAGS="-m31" ;;
587 s390x)
588 CPU_CFLAGS="-m64" ;;
590 sparc|sun4[cdmuv])
591 cpu="sparc"
592 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
593 sparc64)
594 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
595 esac
597 : ${make=${MAKE-make}}
599 # We prefer python 3.x. A bare 'python' is traditionally
600 # python 2.x, but some distros have it as python 3.x, so
601 # we check that too
602 python=
603 explicit_python=no
604 for binary in "${PYTHON-python3}" python
606 if has "$binary"
607 then
608 python=$(command -v "$binary")
609 break
611 done
614 # Check for ancillary tools used in testing
615 genisoimage=
616 for binary in genisoimage mkisofs
618 if has $binary
619 then
620 genisoimage=$(command -v "$binary")
621 break
623 done
625 # Default objcc to clang if available, otherwise use CC
626 if has clang; then
627 objcc=clang
628 else
629 objcc="$cc"
632 if test "$mingw32" = "yes" ; then
633 EXESUF=".exe"
634 # MinGW needs -mthreads for TLS and macro _MT.
635 CONFIGURE_CFLAGS="-mthreads $CONFIGURE_CFLAGS"
636 prefix="/qemu"
637 bindir=""
638 qemu_suffix=""
641 werror=""
643 meson_option_build_array() {
644 printf '['
645 (if test "$targetos" = windows; then
646 IFS=\;
647 else
648 IFS=:
650 for e in $1; do
651 printf '"""'
652 # backslash escape any '\' and '"' characters
653 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
654 printf '""",'
655 done)
656 printf ']\n'
659 . "$source_path/scripts/meson-buildoptions.sh"
661 meson_options=
662 meson_option_add() {
663 meson_options="$meson_options $(quote_sh "$1")"
665 meson_option_parse() {
666 meson_options="$meson_options $(_meson_option_parse "$@")"
667 if test $? -eq 1; then
668 echo "ERROR: unknown option $1"
669 echo "Try '$0 --help' for more information"
670 exit 1
674 for opt do
675 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
676 case "$opt" in
677 --help|-h) show_help=yes
679 --version|-V) exec cat "$source_path/VERSION"
681 --prefix=*) prefix="$optarg"
683 --cross-prefix=*)
685 --cc=*)
687 --host-cc=*) host_cc="$optarg"
689 --cxx=*)
691 --objcc=*) objcc="$optarg"
693 --make=*) make="$optarg"
695 --install=*)
697 --python=*) python="$optarg" ; explicit_python=yes
699 --skip-meson) skip_meson=yes
701 --meson=*) meson="$optarg"
703 --ninja=*) ninja="$optarg"
705 --smbd=*) smbd="$optarg"
707 --extra-cflags=*)
709 --extra-cxxflags=*)
711 --extra-objcflags=*)
713 --extra-ldflags=*)
715 --cross-cc-*)
717 --cross-prefix-*)
719 --enable-debug-info) meson_option_add -Ddebug=true
721 --disable-debug-info) meson_option_add -Ddebug=false
723 --enable-modules)
724 modules="yes"
726 --disable-modules)
727 modules="no"
729 --cpu=*)
731 --target-list=*) target_list="$optarg"
732 if test "$target_list_exclude"; then
733 error_exit "Can't mix --target-list with --target-list-exclude"
736 --target-list-exclude=*) target_list_exclude="$optarg"
737 if test "$target_list"; then
738 error_exit "Can't mix --target-list-exclude with --target-list"
741 --with-default-devices) meson_option_add -Ddefault_devices=true
743 --without-default-devices) meson_option_add -Ddefault_devices=false
745 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
747 --with-devices-*) device_arch=${opt#--with-devices-};
748 device_arch=${device_arch%%=*}
749 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
750 if test -f "$cf"; then
751 device_archs="$device_archs $device_arch"
752 eval "devices_${device_arch}=\$optarg"
753 else
754 error_exit "File $cf does not exist"
757 --without-default-features) # processed above
759 --static)
760 static="yes"
761 QEMU_PKG_CONFIG_FLAGS="--static $QEMU_PKG_CONFIG_FLAGS"
763 --bindir=*) bindir="$optarg"
765 --with-suffix=*) qemu_suffix="$optarg"
767 --host=*|--build=*|\
768 --disable-dependency-tracking|\
769 --sbindir=*|--sharedstatedir=*|\
770 --oldincludedir=*|--datarootdir=*|--infodir=*|\
771 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
772 # These switches are silently ignored, for compatibility with
773 # autoconf-generated configure scripts. This allows QEMU's
774 # configure to be used by RPM and similar macros that set
775 # lots of directory switches by default.
777 --enable-debug-tcg) debug_tcg="yes"
779 --disable-debug-tcg) debug_tcg="no"
781 --enable-debug)
782 # Enable debugging options that aren't excessively noisy
783 debug_tcg="yes"
784 meson_option_parse --enable-debug-mutex ""
785 meson_option_add -Doptimization=0
786 fortify_source="no"
788 --enable-sanitizers) sanitizers="yes"
790 --disable-sanitizers) sanitizers="no"
792 --enable-tsan) tsan="yes"
794 --disable-tsan) tsan="no"
796 --disable-tcg) tcg="disabled"
797 plugins="no"
799 --enable-tcg) tcg="enabled"
801 --disable-system) softmmu="no"
803 --enable-system) softmmu="yes"
805 --disable-user)
806 linux_user="no" ;
807 bsd_user="no" ;
809 --enable-user) ;;
810 --disable-linux-user) linux_user="no"
812 --enable-linux-user) linux_user="yes"
814 --disable-bsd-user) bsd_user="no"
816 --enable-bsd-user) bsd_user="yes"
818 --enable-pie) pie="yes"
820 --disable-pie) pie="no"
822 --enable-werror) werror="yes"
824 --disable-werror) werror="no"
826 --enable-stack-protector) stack_protector="yes"
828 --disable-stack-protector) stack_protector="no"
830 --enable-safe-stack) safe_stack="yes"
832 --disable-safe-stack) safe_stack="no"
834 --enable-cfi)
835 cfi="true";
836 meson_option_add -Db_lto=true
838 --disable-cfi) cfi="false"
840 --disable-fdt) fdt="disabled"
842 --enable-fdt) fdt="enabled"
844 --enable-fdt=git) fdt="internal"
846 --enable-fdt=*) fdt="$optarg"
848 --with-coroutine=*) coroutine="$optarg"
850 --with-git=*) git="$optarg"
852 --with-git-submodules=*)
853 git_submodules_action="$optarg"
855 --enable-plugins) if test "$mingw32" = "yes"; then
856 error_exit "TCG plugins not currently supported on Windows platforms"
857 else
858 plugins="yes"
861 --disable-plugins) plugins="no"
863 --enable-containers) use_containers="yes"
865 --disable-containers) use_containers="no"
867 --gdb=*) gdb_bin="$optarg"
869 --enable-vfio-user-server) vfio_user_server="enabled"
871 --disable-vfio-user-server) vfio_user_server="disabled"
873 # everything else has the same name in configure and meson
874 --*) meson_option_parse "$opt" "$optarg"
876 esac
877 done
879 # test for any invalid configuration combinations
880 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
881 error_exit "Can't enable plugins on non-TCG builds"
884 case $git_submodules_action in
885 update|validate)
886 if test ! -e "$source_path/.git"; then
887 echo "ERROR: cannot $git_submodules_action git submodules without .git"
888 exit 1
891 ignore)
892 if ! test -f "$source_path/ui/keycodemapdb/README"
893 then
894 echo
895 echo "ERROR: missing GIT submodules"
896 echo
897 if test -e "$source_path/.git"; then
898 echo "--with-git-submodules=ignore specified but submodules were not"
899 echo "checked out. Please initialize and update submodules."
900 else
901 echo "This is not a GIT checkout but module content appears to"
902 echo "be missing. Do not use 'git archive' or GitHub download links"
903 echo "to acquire QEMU source archives. Non-GIT builds are only"
904 echo "supported with source archives linked from:"
905 echo
906 echo " https://www.qemu.org/download/#source"
907 echo
908 echo "Developers working with GIT can use scripts/archive-source.sh"
909 echo "if they need to create valid source archives."
911 echo
912 exit 1
916 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
917 exit 1
919 esac
921 default_target_list=""
922 mak_wilds=""
924 if [ "$linux_user" != no ]; then
925 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
926 linux_user=yes
927 elif [ "$linux_user" = yes ]; then
928 error_exit "linux-user not supported on this architecture"
931 if [ "$bsd_user" != no ]; then
932 if [ "$bsd_user" = "" ]; then
933 test $targetos = freebsd && bsd_user=yes
935 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
936 error_exit "bsd-user not supported on this host OS"
939 if [ "$softmmu" = "yes" ]; then
940 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
942 if [ "$linux_user" = "yes" ]; then
943 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
945 if [ "$bsd_user" = "yes" ]; then
946 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
949 for config in $mak_wilds; do
950 target="$(basename "$config" .mak)"
951 if echo "$target_list_exclude" | grep -vq "$target"; then
952 default_target_list="${default_target_list} $target"
954 done
956 if test x"$show_help" = x"yes" ; then
957 cat << EOF
959 Usage: configure [options]
960 Options: [defaults in brackets after descriptions]
962 Standard options:
963 --help print this message
964 --prefix=PREFIX install in PREFIX [$prefix]
965 --target-list=LIST set target list (default: build all)
966 $(echo Available targets: $default_target_list | \
967 fold -s -w 53 | sed -e 's/^/ /')
968 --target-list-exclude=LIST exclude a set of targets from the default target-list
970 Advanced options (experts only):
971 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
972 --cc=CC use C compiler CC [$cc]
973 --host-cc=CC use C compiler CC [$host_cc] for code run at
974 build time
975 --cxx=CXX use C++ compiler CXX [$cxx]
976 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
977 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
978 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
979 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
980 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
981 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
982 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
983 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
984 --make=MAKE use specified make [$make]
985 --python=PYTHON use specified python [$python]
986 --meson=MESON use specified meson [$meson]
987 --ninja=NINJA use specified ninja [$ninja]
988 --smbd=SMBD use specified smbd [$smbd]
989 --with-git=GIT use specified git [$git]
990 --with-git-submodules=update update git submodules (default if .git dir exists)
991 --with-git-submodules=validate fail if git submodules are not up to date
992 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
993 --static enable static build [$static]
994 --bindir=PATH install binaries in PATH
995 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
996 --without-default-features default all --enable-* options to "disabled"
997 --without-default-devices do not include any device that is not needed to
998 start the emulator (only use if you are including
999 desired devices in configs/devices/)
1000 --with-devices-ARCH=NAME override default configs/devices
1001 --enable-debug enable common debug build options
1002 --enable-sanitizers enable default sanitizers
1003 --enable-tsan enable thread sanitizer
1004 --disable-werror disable compilation abort on warning
1005 --disable-stack-protector disable compiler-provided stack protection
1006 --cpu=CPU Build for host CPU [$cpu]
1007 --with-coroutine=BACKEND coroutine backend. Supported options:
1008 ucontext, sigaltstack, windows
1009 --enable-plugins
1010 enable plugins via shared library loading
1011 --disable-containers don't use containers for cross-building
1012 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
1014 meson_options_help
1015 cat << EOF
1016 system all system emulation targets
1017 user supported user emulation targets
1018 linux-user all linux usermode emulation targets
1019 bsd-user all BSD usermode emulation targets
1020 pie Position Independent Executables
1021 modules modules support (non-Windows)
1022 debug-tcg TCG debugging (default is disabled)
1023 debug-info debugging information
1024 safe-stack SafeStack Stack Smash Protection. Depends on
1025 clang/llvm and requires coroutine backend ucontext.
1027 NOTE: The object files are built at the place where configure is launched
1029 exit 0
1032 # Remove old dependency files to make sure that they get properly regenerated
1033 rm -f ./*/config-devices.mak.d
1035 if test -z "$python"
1036 then
1037 error_exit "Python not found. Use --python=/path/to/python"
1039 if ! has "$make"
1040 then
1041 error_exit "GNU make ($make) not found"
1044 # Note that if the Python conditional here evaluates True we will exit
1045 # with status 1 which is a shell 'false' value.
1046 if ! $python -c 'import sys; sys.exit(sys.version_info < (3,6))'; then
1047 error_exit "Cannot use '$python', Python >= 3.6 is required." \
1048 "Use --python=/path/to/python to specify a supported Python."
1051 # Suppress writing compiled files
1052 python="$python -B"
1054 if test -z "$meson"; then
1055 if test "$explicit_python" = no && has meson && version_ge "$(meson --version)" 0.61.5; then
1056 meson=meson
1057 elif test "$git_submodules_action" != 'ignore' ; then
1058 meson=git
1059 elif test -e "${source_path}/meson/meson.py" ; then
1060 meson=internal
1061 else
1062 if test "$explicit_python" = yes; then
1063 error_exit "--python requires using QEMU's embedded Meson distribution, but it was not found."
1064 else
1065 error_exit "Meson not found. Use --meson=/path/to/meson"
1068 else
1069 # Meson uses its own Python interpreter to invoke other Python scripts,
1070 # but the user wants to use the one they specified with --python.
1072 # We do not want to override the distro Python interpreter (and sometimes
1073 # cannot: for example in Homebrew /usr/bin/meson is a bash script), so
1074 # just require --meson=git|internal together with --python.
1075 if test "$explicit_python" = yes; then
1076 case "$meson" in
1077 git | internal) ;;
1078 *) error_exit "--python requires using QEMU's embedded Meson distribution." ;;
1079 esac
1083 if test "$meson" = git; then
1084 git_submodules="${git_submodules} meson"
1087 case "$meson" in
1088 git | internal)
1089 meson="$python ${source_path}/meson/meson.py"
1091 *) meson=$(command -v "$meson") ;;
1092 esac
1094 # Probe for ninja
1096 if test -z "$ninja"; then
1097 for c in ninja ninja-build samu; do
1098 if has $c; then
1099 ninja=$(command -v "$c")
1100 break
1102 done
1103 if test -z "$ninja"; then
1104 error_exit "Cannot find Ninja"
1108 # Check that the C compiler works. Doing this here before testing
1109 # the host CPU ensures that we had a valid CC to autodetect the
1110 # $cpu var (and we should bail right here if that's not the case).
1111 # It also allows the help message to be printed without a CC.
1112 write_c_skeleton;
1113 if compile_object ; then
1114 : C compiler works ok
1115 else
1116 error_exit "\"$cc\" either does not exist or does not work"
1118 if ! compile_prog ; then
1119 error_exit "\"$cc\" cannot build an executable (is your linker broken?)"
1122 # Consult white-list to determine whether to enable werror
1123 # by default. Only enable by default for git builds
1124 if test -z "$werror" ; then
1125 if test "$git_submodules_action" != "ignore" && \
1126 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1127 werror="yes"
1128 else
1129 werror="no"
1133 if test "$targetos" = "bogus"; then
1134 # Now that we know that we're not printing the help and that
1135 # the compiler works (so the results of the check_defines we used
1136 # to identify the OS are reliable), if we didn't recognize the
1137 # host OS we should stop now.
1138 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1141 # Check whether the compiler matches our minimum requirements:
1142 cat > $TMPC << EOF
1143 #if defined(__clang_major__) && defined(__clang_minor__)
1144 # ifdef __apple_build_version__
1145 # if __clang_major__ < 12 || (__clang_major__ == 12 && __clang_minor__ < 0)
1146 # error You need at least XCode Clang v12.0 to compile QEMU
1147 # endif
1148 # else
1149 # if __clang_major__ < 10 || (__clang_major__ == 10 && __clang_minor__ < 0)
1150 # error You need at least Clang v10.0 to compile QEMU
1151 # endif
1152 # endif
1153 #elif defined(__GNUC__) && defined(__GNUC_MINOR__)
1154 # if __GNUC__ < 7 || (__GNUC__ == 7 && __GNUC_MINOR__ < 4)
1155 # error You need at least GCC v7.4.0 to compile QEMU
1156 # endif
1157 #else
1158 # error You either need GCC or Clang to compiler QEMU
1159 #endif
1160 int main (void) { return 0; }
1162 if ! compile_prog "" "" ; then
1163 error_exit "You need at least GCC v7.4 or Clang v10.0 (or XCode Clang v12.0)"
1166 # Accumulate -Wfoo and -Wno-bar separately.
1167 # We will list all of the enable flags first, and the disable flags second.
1168 # Note that we do not add -Werror, because that would enable it for all
1169 # configure tests. If a configure test failed due to -Werror this would
1170 # just silently disable some features, so it's too error prone.
1172 warn_flags=
1173 add_to warn_flags -Wundef
1174 add_to warn_flags -Wwrite-strings
1175 add_to warn_flags -Wmissing-prototypes
1176 add_to warn_flags -Wstrict-prototypes
1177 add_to warn_flags -Wredundant-decls
1178 add_to warn_flags -Wold-style-declaration
1179 add_to warn_flags -Wold-style-definition
1180 add_to warn_flags -Wtype-limits
1181 add_to warn_flags -Wformat-security
1182 add_to warn_flags -Wformat-y2k
1183 add_to warn_flags -Winit-self
1184 add_to warn_flags -Wignored-qualifiers
1185 add_to warn_flags -Wempty-body
1186 add_to warn_flags -Wnested-externs
1187 add_to warn_flags -Wendif-labels
1188 add_to warn_flags -Wexpansion-to-defined
1189 add_to warn_flags -Wimplicit-fallthrough=2
1190 add_to warn_flags -Wmissing-format-attribute
1191 add_to warn_flags -Wthread-safety
1193 nowarn_flags=
1194 add_to nowarn_flags -Wno-initializer-overrides
1195 add_to nowarn_flags -Wno-missing-include-dirs
1196 add_to nowarn_flags -Wno-shift-negative-value
1197 add_to nowarn_flags -Wno-string-plus-int
1198 add_to nowarn_flags -Wno-typedef-redefinition
1199 add_to nowarn_flags -Wno-tautological-type-limit-compare
1200 add_to nowarn_flags -Wno-psabi
1201 add_to nowarn_flags -Wno-gnu-variable-sized-type-not-at-end
1203 gcc_flags="$warn_flags $nowarn_flags"
1205 cc_has_warning_flag() {
1206 write_c_skeleton;
1208 # Use the positive sense of the flag when testing for -Wno-wombat
1209 # support (gcc will happily accept the -Wno- form of unknown
1210 # warning options).
1211 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1212 compile_prog "-Werror $optflag" ""
1215 objcc_has_warning_flag() {
1216 cat > $TMPM <<EOF
1217 int main(void) { return 0; }
1220 # Use the positive sense of the flag when testing for -Wno-wombat
1221 # support (gcc will happily accept the -Wno- form of unknown
1222 # warning options).
1223 optflag="$(echo $1 | sed -e 's/^-Wno-/-W/')"
1224 do_objc -Werror $optflag \
1225 $OBJCFLAGS $EXTRA_OBJCFLAGS $CONFIGURE_OBJCFLAGS $QEMU_OBJCFLAGS \
1226 -o $TMPE $TMPM $QEMU_LDFLAGS
1229 for flag in $gcc_flags; do
1230 if cc_has_warning_flag $flag ; then
1231 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1233 if objcc_has_warning_flag $flag ; then
1234 QEMU_OBJCFLAGS="$QEMU_OBJCFLAGS $flag"
1236 done
1238 if test "$stack_protector" != "no"; then
1239 cat > $TMPC << EOF
1240 int main(int argc, char *argv[])
1242 char arr[64], *p = arr, *c = argv[argc - 1];
1243 while (*c) {
1244 *p++ = *c++;
1246 return 0;
1249 gcc_flags="-fstack-protector-strong -fstack-protector-all"
1250 sp_on=0
1251 for flag in $gcc_flags; do
1252 # We need to check both a compile and a link, since some compiler
1253 # setups fail only on a .c->.o compile and some only at link time
1254 if compile_object "-Werror $flag" &&
1255 compile_prog "-Werror $flag" ""; then
1256 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1257 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1258 sp_on=1
1259 break
1261 done
1262 if test "$stack_protector" = yes; then
1263 if test $sp_on = 0; then
1264 error_exit "Stack protector not supported"
1269 # Our module code doesn't support Windows
1270 if test "$modules" = "yes" && test "$mingw32" = "yes" ; then
1271 error_exit "Modules are not available for Windows"
1274 # Static linking is not possible with plugins, modules or PIE
1275 if test "$static" = "yes" ; then
1276 if test "$modules" = "yes" ; then
1277 error_exit "static and modules are mutually incompatible"
1279 if test "$plugins" = "yes"; then
1280 error_exit "static and plugins are mutually incompatible"
1281 else
1282 plugins="no"
1285 test "$plugins" = "" && plugins=yes
1287 cat > $TMPC << EOF
1289 #ifdef __linux__
1290 # define THREAD __thread
1291 #else
1292 # define THREAD
1293 #endif
1294 static THREAD int tls_var;
1295 int main(void) { return tls_var; }
1298 # Meson currently only handles pie as a boolean for now so if we have
1299 # explicitly disabled PIE we need to extend our cflags because it wont.
1300 if test "$static" = "yes"; then
1301 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1302 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1303 pie="yes"
1304 elif test "$pie" = "yes"; then
1305 error_exit "-static-pie not available due to missing toolchain support"
1306 else
1307 pie="no"
1308 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1310 elif test "$pie" = "no"; then
1311 if compile_prog "-Werror -fno-pie" "-no-pie"; then
1312 CONFIGURE_CFLAGS="-fno-pie $CONFIGURE_CFLAGS"
1313 CONFIGURE_LDFLAGS="-no-pie $CONFIGURE_LDFLAGS"
1314 QEMU_CFLAGS="-fno-pie -no-pie $QEMU_CFLAGS"
1316 elif compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1317 CONFIGURE_CFLAGS="-fPIE -DPIE $CONFIGURE_CFLAGS"
1318 CONFIGURE_LDFLAGS="-pie $CONFIGURE_LDFLAGS"
1319 pie="yes"
1320 elif test "$pie" = "yes"; then
1321 error_exit "PIE not available due to missing toolchain support"
1322 else
1323 echo "Disabling PIE due to missing toolchain support"
1324 pie="no"
1327 ##########################################
1328 # __sync_fetch_and_and requires at least -march=i486. Many toolchains
1329 # use i686 as default anyway, but for those that don't, an explicit
1330 # specification is necessary
1332 if test "$cpu" = "i386"; then
1333 cat > $TMPC << EOF
1334 static int sfaa(int *ptr)
1336 return __sync_fetch_and_and(ptr, 0);
1339 int main(void)
1341 int val = 42;
1342 val = __sync_val_compare_and_swap(&val, 0, 1);
1343 sfaa(&val);
1344 return val;
1347 if ! compile_prog "" "" ; then
1348 QEMU_CFLAGS="-march=i486 $QEMU_CFLAGS"
1352 if test -z "${target_list+xxx}" ; then
1353 default_targets=yes
1354 for target in $default_target_list; do
1355 target_list="$target_list $target"
1356 done
1357 target_list="${target_list# }"
1358 else
1359 default_targets=no
1360 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1361 for target in $target_list; do
1362 # Check that we recognised the target name; this allows a more
1363 # friendly error message than if we let it fall through.
1364 case " $default_target_list " in
1365 *" $target "*)
1368 error_exit "Unknown target name '$target'"
1370 esac
1371 done
1374 # see if system emulation was really requested
1375 case " $target_list " in
1376 *"-softmmu "*) softmmu=yes
1378 *) softmmu=no
1380 esac
1382 if test "$tcg" = "auto"; then
1383 if test -z "$target_list"; then
1384 tcg="disabled"
1385 else
1386 tcg="enabled"
1390 if test "$tcg" = "enabled"; then
1391 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1392 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1395 ##########################################
1396 # big/little endian test
1397 cat > $TMPC << EOF
1398 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1399 # error LITTLE
1400 #endif
1401 int main(void) { return 0; }
1404 if ! compile_prog ; then
1405 bigendian="no"
1406 else
1407 cat > $TMPC << EOF
1408 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1409 # error BIG
1410 #endif
1411 int main(void) { return 0; }
1414 if ! compile_prog ; then
1415 bigendian="yes"
1416 else
1417 echo big/little test failed
1418 exit 1
1422 ##########################################
1423 # pkg-config probe
1425 if ! has "$pkg_config_exe"; then
1426 error_exit "pkg-config binary '$pkg_config_exe' not found"
1429 ##########################################
1430 # glib support probe
1432 # When bumping glib_req_ver, please check also whether we should increase
1433 # the _WIN32_WINNT setting in osdep.h according to the value from glib
1434 glib_req_ver=2.56
1435 glib_modules=gthread-2.0
1436 if test "$modules" = yes; then
1437 glib_modules="$glib_modules gmodule-export-2.0"
1438 elif test "$plugins" = "yes"; then
1439 glib_modules="$glib_modules gmodule-no-export-2.0"
1442 for i in $glib_modules; do
1443 if $pkg_config --atleast-version=$glib_req_ver $i; then
1444 glib_cflags=$($pkg_config --cflags $i)
1445 glib_libs=$($pkg_config --libs $i)
1446 else
1447 error_exit "glib-$glib_req_ver $i is required to compile QEMU"
1449 done
1451 glib_bindir="$($pkg_config --variable=bindir glib-2.0)"
1452 if test -z "$glib_bindir" ; then
1453 glib_bindir="$($pkg_config --variable=prefix glib-2.0)"/bin
1456 # This workaround is required due to a bug in pkg-config file for glib as it
1457 # doesn't define GLIB_STATIC_COMPILATION for pkg-config --static
1459 if test "$static" = yes && test "$mingw32" = yes; then
1460 glib_cflags="-DGLIB_STATIC_COMPILATION $glib_cflags"
1463 # Sanity check that the current size_t matches the
1464 # size that glib thinks it should be. This catches
1465 # problems on multi-arch where people try to build
1466 # 32-bit QEMU while pointing at 64-bit glib headers
1467 cat > $TMPC <<EOF
1468 #include <glib.h>
1469 #include <unistd.h>
1471 #define QEMU_BUILD_BUG_ON(x) \
1472 typedef char qemu_build_bug_on[(x)?-1:1] __attribute__((unused));
1474 int main(void) {
1475 QEMU_BUILD_BUG_ON(sizeof(size_t) != GLIB_SIZEOF_SIZE_T);
1476 return 0;
1480 if ! compile_prog "$glib_cflags" "$glib_libs" ; then
1481 error_exit "sizeof(size_t) doesn't match GLIB_SIZEOF_SIZE_T."\
1482 "You probably need to set PKG_CONFIG_LIBDIR"\
1483 "to point to the right pkg-config files for your"\
1484 "build target"
1487 # Silence clang warnings triggered by glib < 2.57.2
1488 cat > $TMPC << EOF
1489 #include <glib.h>
1490 typedef struct Foo {
1491 int i;
1492 } Foo;
1493 static void foo_free(Foo *f)
1495 g_free(f);
1497 G_DEFINE_AUTOPTR_CLEANUP_FUNC(Foo, foo_free)
1498 int main(void) { return 0; }
1500 if ! compile_prog "$glib_cflags -Werror" "$glib_libs" ; then
1501 if cc_has_warning_flag "-Wno-unused-function"; then
1502 glib_cflags="$glib_cflags -Wno-unused-function"
1503 CONFIGURE_CFLAGS="$CONFIGURE_CFLAGS -Wno-unused-function"
1507 ##########################################
1508 # fdt probe
1510 case "$fdt" in
1511 auto | enabled | internal)
1512 # Simpler to always update submodule, even if not needed.
1513 git_submodules="${git_submodules} dtc"
1515 esac
1517 ##########################################
1518 # check and set a backend for coroutine
1520 # We prefer ucontext, but it's not always possible. The fallback
1521 # is sigcontext. On Windows the only valid backend is the Windows
1522 # specific one.
1524 ucontext_works=no
1525 if test "$darwin" != "yes"; then
1526 cat > $TMPC << EOF
1527 #include <ucontext.h>
1528 #ifdef __stub_makecontext
1529 #error Ignoring glibc stub makecontext which will always fail
1530 #endif
1531 int main(void) { makecontext(0, 0, 0); return 0; }
1533 if compile_prog "" "" ; then
1534 ucontext_works=yes
1538 if test "$coroutine" = ""; then
1539 if test "$mingw32" = "yes"; then
1540 coroutine=win32
1541 elif test "$ucontext_works" = "yes"; then
1542 coroutine=ucontext
1543 else
1544 coroutine=sigaltstack
1546 else
1547 case $coroutine in
1548 windows)
1549 if test "$mingw32" != "yes"; then
1550 error_exit "'windows' coroutine backend only valid for Windows"
1552 # Unfortunately the user visible backend name doesn't match the
1553 # coroutine-*.c filename for this case, so we have to adjust it here.
1554 coroutine=win32
1556 ucontext)
1557 if test "$ucontext_works" != "yes"; then
1558 error_exit "'ucontext' backend requested but makecontext not available"
1561 sigaltstack)
1562 if test "$mingw32" = "yes"; then
1563 error_exit "only the 'windows' coroutine backend is valid for Windows"
1567 error_exit "unknown coroutine backend $coroutine"
1569 esac
1572 ##################################################
1573 # SafeStack
1576 if test "$safe_stack" = "yes"; then
1577 cat > $TMPC << EOF
1578 int main(void)
1580 #if ! __has_feature(safe_stack)
1581 #error SafeStack Disabled
1582 #endif
1583 return 0;
1586 flag="-fsanitize=safe-stack"
1587 # Check that safe-stack is supported and enabled.
1588 if compile_prog "-Werror $flag" "$flag"; then
1589 # Flag needed both at compilation and at linking
1590 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1591 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1592 else
1593 error_exit "SafeStack not supported by your compiler"
1595 if test "$coroutine" != "ucontext"; then
1596 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1598 else
1599 cat > $TMPC << EOF
1600 int main(void)
1602 #if defined(__has_feature)
1603 #if __has_feature(safe_stack)
1604 #error SafeStack Enabled
1605 #endif
1606 #endif
1607 return 0;
1610 if test "$safe_stack" = "no"; then
1611 # Make sure that safe-stack is disabled
1612 if ! compile_prog "-Werror" ""; then
1613 # SafeStack was already enabled, try to explicitly remove the feature
1614 flag="-fno-sanitize=safe-stack"
1615 if ! compile_prog "-Werror $flag" "$flag"; then
1616 error_exit "Configure cannot disable SafeStack"
1618 QEMU_CFLAGS="$QEMU_CFLAGS $flag"
1619 QEMU_LDFLAGS="$QEMU_LDFLAGS $flag"
1621 else # "$safe_stack" = ""
1622 # Set safe_stack to yes or no based on pre-existing flags
1623 if compile_prog "-Werror" ""; then
1624 safe_stack="no"
1625 else
1626 safe_stack="yes"
1627 if test "$coroutine" != "ucontext"; then
1628 error_exit "SafeStack is only supported by the coroutine backend ucontext"
1634 ########################################
1635 # check if ccache is interfering with
1636 # semantic analysis of macros
1638 unset CCACHE_CPP2
1639 ccache_cpp2=no
1640 cat > $TMPC << EOF
1641 static const int Z = 1;
1642 #define fn() ({ Z; })
1643 #define TAUT(X) ((X) == Z)
1644 #define PAREN(X, Y) (X == Y)
1645 #define ID(X) (X)
1646 int main(void)
1648 int x = 0, y = 0;
1649 x = ID(x);
1650 x = fn();
1651 fn();
1652 if (PAREN(x, y)) return 0;
1653 if (TAUT(Z)) return 0;
1654 return 0;
1658 if ! compile_object "-Werror"; then
1659 ccache_cpp2=yes
1662 #################################################
1663 # clang does not support glibc + FORTIFY_SOURCE.
1665 if test "$fortify_source" != "no"; then
1666 if echo | $cc -dM -E - | grep __clang__ > /dev/null 2>&1 ; then
1667 fortify_source="no";
1668 elif test -n "$cxx" && has $cxx &&
1669 echo | $cxx -dM -E - | grep __clang__ >/dev/null 2>&1 ; then
1670 fortify_source="no";
1671 else
1672 fortify_source="yes"
1676 ##########################################
1677 # checks for sanitizers
1679 have_asan=no
1680 have_ubsan=no
1681 have_asan_iface_h=no
1682 have_asan_iface_fiber=no
1684 if test "$sanitizers" = "yes" ; then
1685 write_c_skeleton
1686 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" ""; then
1687 have_asan=yes
1690 # we could use a simple skeleton for flags checks, but this also
1691 # detect the static linking issue of ubsan, see also:
1692 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84285
1693 cat > $TMPC << EOF
1694 #include <stdlib.h>
1695 int main(void) {
1696 void *tmp = malloc(10);
1697 if (tmp != NULL) {
1698 return *(int *)(tmp + 2);
1700 return 1;
1703 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=undefined" ""; then
1704 have_ubsan=yes
1707 if check_include "sanitizer/asan_interface.h" ; then
1708 have_asan_iface_h=yes
1711 cat > $TMPC << EOF
1712 #include <sanitizer/asan_interface.h>
1713 int main(void) {
1714 __sanitizer_start_switch_fiber(0, 0, 0);
1715 return 0;
1718 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=address" "" ; then
1719 have_asan_iface_fiber=yes
1723 # Thread sanitizer is, for now, much noisier than the other sanitizers;
1724 # keep it separate until that is not the case.
1725 if test "$tsan" = "yes" && test "$sanitizers" = "yes"; then
1726 error_exit "TSAN is not supported with other sanitiziers."
1728 have_tsan=no
1729 have_tsan_iface_fiber=no
1730 if test "$tsan" = "yes" ; then
1731 write_c_skeleton
1732 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1733 have_tsan=yes
1735 cat > $TMPC << EOF
1736 #include <sanitizer/tsan_interface.h>
1737 int main(void) {
1738 __tsan_create_fiber(0);
1739 return 0;
1742 if compile_prog "$CPU_CFLAGS -Werror -fsanitize=thread" "" ; then
1743 have_tsan_iface_fiber=yes
1747 ##########################################
1748 # functions to probe cross compilers
1750 container="no"
1751 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1752 case $($python "$source_path"/tests/docker/docker.py probe) in
1753 *docker) container=docker ;;
1754 podman) container=podman ;;
1755 no) container=no ;;
1756 esac
1757 if test "$container" != "no"; then
1758 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1762 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1763 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1764 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1765 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1766 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1767 : ${cross_prefix_armeb="$cross_prefix_arm"}
1768 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1769 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1770 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1771 : ${cross_prefix_i386="i686-linux-gnu-"}
1772 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1773 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1774 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1775 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1776 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1777 : ${cross_prefix_mips="mips-linux-gnu-"}
1778 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1779 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1780 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1781 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1782 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1783 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1784 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1785 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1786 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1787 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1789 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1790 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1791 : ${cross_cc_armeb="$cross_cc_arm"}
1792 : ${cross_cc_cflags_armeb="-mbig-endian"}
1793 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1794 : ${cross_cc_cflags_hexagon="-mv67 -O2 -static"}
1795 : ${cross_cc_cflags_i386="-m32"}
1796 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1797 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1798 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1799 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1800 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1801 : ${cross_cc_sparc="$cross_cc_sparc64"}
1802 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1803 : ${cross_cc_cflags_x86_64="-m64"}
1805 compute_target_variable() {
1806 eval "$2="
1807 if eval test -n "\"\${cross_prefix_$1}\""; then
1808 if eval has "\"\${cross_prefix_$1}\$3\""; then
1809 eval "$2=\"\${cross_prefix_$1}\$3\""
1814 have_target() {
1815 for i; do
1816 case " $target_list " in
1817 *" $i "*) return 0;;
1818 *) ;;
1819 esac
1820 done
1821 return 1
1824 # probe_target_compiler TARGET
1826 # Look for a compiler for the given target, either native or cross.
1827 # Set variables target_* if a compiler is found, and container_cross_*
1828 # if a Docker-based cross-compiler image is known for the target.
1829 # Set got_cross_cc to yes/no depending on whether a non-container-based
1830 # compiler was found.
1832 # If TARGET is a user-mode emulation target, also set build_static to
1833 # "y" if static linking is possible.
1835 probe_target_compiler() {
1836 # reset all output variables
1837 got_cross_cc=no
1838 container_image=
1839 container_hosts=
1840 container_cross_cc=
1841 container_cross_ar=
1842 container_cross_as=
1843 container_cross_ld=
1844 container_cross_nm=
1845 container_cross_objcopy=
1846 container_cross_ranlib=
1847 container_cross_strip=
1849 # We shall skip configuring the target compiler if the user didn't
1850 # bother enabling an appropriate guest. This avoids building
1851 # extraneous firmware images and tests.
1852 if test "${target_list#*$1}" = "$1"; then
1853 return 1
1856 target_arch=${1%%-*}
1857 case $target_arch in
1858 aarch64) container_hosts="x86_64 aarch64" ;;
1859 alpha) container_hosts=x86_64 ;;
1860 arm) container_hosts="x86_64 aarch64" ;;
1861 cris) container_hosts=x86_64 ;;
1862 hexagon) container_hosts=x86_64 ;;
1863 hppa) container_hosts=x86_64 ;;
1864 i386) container_hosts=x86_64 ;;
1865 loongarch64) container_hosts=x86_64 ;;
1866 m68k) container_hosts=x86_64 ;;
1867 microblaze) container_hosts=x86_64 ;;
1868 mips64el) container_hosts=x86_64 ;;
1869 mips64) container_hosts=x86_64 ;;
1870 mipsel) container_hosts=x86_64 ;;
1871 mips) container_hosts=x86_64 ;;
1872 nios2) container_hosts=x86_64 ;;
1873 ppc) container_hosts=x86_64 ;;
1874 ppc64|ppc64le) container_hosts=x86_64 ;;
1875 riscv64) container_hosts=x86_64 ;;
1876 s390x) container_hosts=x86_64 ;;
1877 sh4) container_hosts=x86_64 ;;
1878 sparc64) container_hosts=x86_64 ;;
1879 tricore) container_hosts=x86_64 ;;
1880 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1881 xtensa*) container_hosts=x86_64 ;;
1882 esac
1884 for host in $container_hosts; do
1885 test "$container" != no || continue
1886 test "$host" = "$cpu" || continue
1887 case $target_arch in
1888 aarch64)
1889 # We don't have any bigendian build tools so we only use this for AArch64
1890 container_image=debian-arm64-cross
1891 container_cross_prefix=aarch64-linux-gnu-
1892 container_cross_cc=${container_cross_prefix}gcc-10
1894 alpha)
1895 container_image=debian-alpha-cross
1896 container_cross_prefix=alpha-linux-gnu-
1898 arm)
1899 # We don't have any bigendian build tools so we only use this for ARM
1900 container_image=debian-armhf-cross
1901 container_cross_prefix=arm-linux-gnueabihf-
1903 cris)
1904 container_image=fedora-cris-cross
1905 container_cross_prefix=cris-linux-gnu-
1907 hexagon)
1908 container_image=debian-hexagon-cross
1909 container_cross_prefix=hexagon-unknown-linux-musl-
1910 container_cross_cc=${container_cross_prefix}clang
1912 hppa)
1913 container_image=debian-hppa-cross
1914 container_cross_prefix=hppa-linux-gnu-
1916 i386)
1917 container_image=fedora-i386-cross
1918 container_cross_prefix=
1920 loongarch64)
1921 container_image=debian-loongarch-cross
1922 container_cross_prefix=loongarch64-unknown-linux-gnu-
1924 m68k)
1925 container_image=debian-m68k-cross
1926 container_cross_prefix=m68k-linux-gnu-
1928 microblaze)
1929 container_image=debian-microblaze-cross
1930 container_cross_prefix=microblaze-linux-musl-
1932 mips64el)
1933 container_image=debian-mips64el-cross
1934 container_cross_prefix=mips64el-linux-gnuabi64-
1936 mips64)
1937 container_image=debian-mips64-cross
1938 container_cross_prefix=mips64-linux-gnuabi64-
1940 mipsel)
1941 container_image=debian-mipsel-cross
1942 container_cross_prefix=mipsel-linux-gnu-
1944 mips)
1945 container_image=debian-mips-cross
1946 container_cross_prefix=mips-linux-gnu-
1948 nios2)
1949 container_image=debian-nios2-cross
1950 container_cross_prefix=nios2-linux-gnu-
1952 ppc)
1953 container_image=debian-powerpc-test-cross
1954 container_cross_prefix=powerpc-linux-gnu-
1955 container_cross_cc=${container_cross_prefix}gcc-10
1957 ppc64|ppc64le)
1958 container_image=debian-powerpc-test-cross
1959 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
1960 container_cross_cc=${container_cross_prefix}gcc-10
1962 riscv64)
1963 container_image=debian-riscv64-test-cross
1964 container_cross_prefix=riscv64-linux-gnu-
1966 s390x)
1967 container_image=debian-s390x-cross
1968 container_cross_prefix=s390x-linux-gnu-
1970 sh4)
1971 container_image=debian-sh4-cross
1972 container_cross_prefix=sh4-linux-gnu-
1974 sparc64)
1975 container_image=debian-sparc64-cross
1976 container_cross_prefix=sparc64-linux-gnu-
1978 tricore)
1979 container_image=debian-tricore-cross
1980 container_cross_prefix=tricore-
1981 container_cross_as=tricore-as
1982 container_cross_ld=tricore-ld
1983 break
1985 x86_64)
1986 container_image=debian-amd64-cross
1987 container_cross_prefix=x86_64-linux-gnu-
1989 xtensa*)
1990 container_hosts=x86_64
1991 container_image=debian-xtensa-cross
1993 # default to the dc232b cpu
1994 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
1996 esac
1997 : ${container_cross_cc:=${container_cross_prefix}gcc}
1998 : ${container_cross_ar:=${container_cross_prefix}ar}
1999 : ${container_cross_as:=${container_cross_prefix}as}
2000 : ${container_cross_ld:=${container_cross_prefix}ld}
2001 : ${container_cross_nm:=${container_cross_prefix}nm}
2002 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
2003 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
2004 : ${container_cross_strip:=${container_cross_prefix}strip}
2005 done
2007 try=cross
2008 case "$target_arch:$cpu" in
2009 aarch64_be:aarch64 | \
2010 armeb:arm | \
2011 i386:x86_64 | \
2012 mips*:mips64 | \
2013 ppc*:ppc64 | \
2014 sparc:sparc64 | \
2015 "$cpu:$cpu")
2016 try='native cross' ;;
2017 esac
2018 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
2019 for thistry in $try; do
2020 case $thistry in
2021 native)
2022 target_cc=$cc
2023 target_ccas=$ccas
2024 target_ar=$ar
2025 target_as=$as
2026 target_ld=$ld
2027 target_nm=$nm
2028 target_objcopy=$objcopy
2029 target_ranlib=$ranlib
2030 target_strip=$strip
2032 cross)
2033 target_cc=
2034 if eval test -n "\"\${cross_cc_$target_arch}\""; then
2035 if eval has "\"\${cross_cc_$target_arch}\""; then
2036 eval "target_cc=\"\${cross_cc_$target_arch}\""
2038 else
2039 compute_target_variable $target_arch target_cc gcc
2041 target_ccas=$target_cc
2042 compute_target_variable $target_arch target_ar ar
2043 compute_target_variable $target_arch target_as as
2044 compute_target_variable $target_arch target_ld ld
2045 compute_target_variable $target_arch target_nm nm
2046 compute_target_variable $target_arch target_objcopy objcopy
2047 compute_target_variable $target_arch target_ranlib ranlib
2048 compute_target_variable $target_arch target_strip strip
2050 esac
2052 if test -n "$target_cc"; then
2053 case $target_arch in
2054 i386|x86_64)
2055 if $target_cc --version | grep -qi "clang"; then
2056 continue
2059 esac
2060 elif test -n "$target_as" && test -n "$target_ld"; then
2061 # Special handling for assembler only targets
2062 case $target in
2063 tricore-softmmu)
2064 build_static=
2065 got_cross_cc=yes
2066 break
2069 continue
2071 esac
2072 else
2073 continue
2076 write_c_skeleton
2077 case $1 in
2078 *-softmmu)
2079 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
2080 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
2081 got_cross_cc=yes
2082 break
2086 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
2087 build_static=y
2088 got_cross_cc=yes
2089 break
2091 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
2092 build_static=
2093 got_cross_cc=yes
2094 break
2097 esac
2098 done
2099 if test $got_cross_cc != yes; then
2100 build_static=
2101 target_cc=
2102 target_ccas=
2103 target_ar=
2104 target_as=
2105 target_ld=
2106 target_nm=
2107 target_objcopy=
2108 target_ranlib=
2109 target_strip=
2111 test -n "$target_cc"
2114 write_target_makefile() {
2115 echo "EXTRA_CFLAGS=$target_cflags"
2116 if test -z "$target_cc" && test -z "$target_as"; then
2117 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
2118 echo "$1: docker-image-$container_image" >> Makefile.prereqs
2119 if test -n "$container_cross_cc"; then
2120 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2121 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
2123 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
2124 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
2125 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
2126 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
2127 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
2128 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
2129 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
2130 else
2131 if test -n "$target_cc"; then
2132 echo "CC=$target_cc"
2133 echo "CCAS=$target_ccas"
2135 if test -n "$target_ar"; then
2136 echo "AR=$target_ar"
2138 if test -n "$target_as"; then
2139 echo "AS=$target_as"
2141 if test -n "$target_ld"; then
2142 echo "LD=$target_ld"
2144 if test -n "$target_nm"; then
2145 echo "NM=$target_nm"
2147 if test -n "$target_objcopy"; then
2148 echo "OBJCOPY=$target_objcopy"
2150 if test -n "$target_ranlib"; then
2151 echo "RANLIB=$target_ranlib"
2153 if test -n "$target_strip"; then
2154 echo "STRIP=$target_strip"
2159 ##########################################
2160 # check for vfio_user_server
2162 case "$vfio_user_server" in
2163 enabled )
2164 if test "$git_submodules_action" != "ignore"; then
2165 git_submodules="${git_submodules} subprojects/libvfio-user"
2168 esac
2170 ##########################################
2171 # End of CC checks
2172 # After here, no more $cc or $ld runs
2174 write_c_skeleton
2176 if test "$fortify_source" = "yes" ; then
2177 QEMU_CFLAGS="-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 $QEMU_CFLAGS"
2180 if test "$have_asan" = "yes"; then
2181 QEMU_CFLAGS="-fsanitize=address $QEMU_CFLAGS"
2182 QEMU_LDFLAGS="-fsanitize=address $QEMU_LDFLAGS"
2183 if test "$have_asan_iface_h" = "no" ; then
2184 echo "ASAN build enabled, but ASAN header missing." \
2185 "Without code annotation, the report may be inferior."
2186 elif test "$have_asan_iface_fiber" = "no" ; then
2187 echo "ASAN build enabled, but ASAN header is too old." \
2188 "Without code annotation, the report may be inferior."
2191 if test "$have_tsan" = "yes" ; then
2192 if test "$have_tsan_iface_fiber" = "yes" ; then
2193 QEMU_CFLAGS="-fsanitize=thread $QEMU_CFLAGS"
2194 QEMU_LDFLAGS="-fsanitize=thread $QEMU_LDFLAGS"
2195 else
2196 error_exit "Cannot enable TSAN due to missing fiber annotation interface."
2198 elif test "$tsan" = "yes" ; then
2199 error_exit "Cannot enable TSAN due to missing sanitize thread interface."
2201 if test "$have_ubsan" = "yes"; then
2202 QEMU_CFLAGS="-fsanitize=undefined $QEMU_CFLAGS"
2203 QEMU_LDFLAGS="-fsanitize=undefined $QEMU_LDFLAGS"
2206 #######################################
2207 # cross-compiled firmware targets
2209 # Set up build tree symlinks that point back into the source tree
2210 # (these can be both files and directories).
2211 # Caution: avoid adding files or directories here using wildcards. This
2212 # will result in problems later if a new file matching the wildcard is
2213 # added to the source tree -- nothing will cause configure to be rerun
2214 # so the build tree will be missing the link back to the new file, and
2215 # tests might fail. Prefer to keep the relevant files in their own
2216 # directory and symlink the directory instead.
2217 LINKS="Makefile"
2218 LINKS="$LINKS pc-bios/optionrom/Makefile"
2219 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
2220 LINKS="$LINKS pc-bios/vof/Makefile"
2221 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
2222 LINKS="$LINKS tests/avocado tests/data"
2223 LINKS="$LINKS tests/qemu-iotests/check"
2224 LINKS="$LINKS python"
2225 LINKS="$LINKS contrib/plugins/Makefile "
2226 for f in $LINKS ; do
2227 if [ -e "$source_path/$f" ]; then
2228 mkdir -p "$(dirname ./"$f")"
2229 symlink "$source_path/$f" "$f"
2231 done
2233 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
2235 # Mac OS X ships with a broken assembler
2236 roms=
2237 if have_target i386-softmmu x86_64-softmmu && \
2238 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
2239 test "$targetos" != "haiku" && \
2240 probe_target_compiler i386-softmmu; then
2241 roms="pc-bios/optionrom"
2242 config_mak=pc-bios/optionrom/config.mak
2243 echo "# Automatically generated by configure - do not modify" > $config_mak
2244 echo "TOPSRC_DIR=$source_path" >> $config_mak
2245 write_target_makefile >> $config_mak
2248 if have_target ppc-softmmu ppc64-softmmu && \
2249 probe_target_compiler ppc-softmmu; then
2250 roms="$roms pc-bios/vof"
2251 config_mak=pc-bios/vof/config.mak
2252 echo "# Automatically generated by configure - do not modify" > $config_mak
2253 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
2254 write_target_makefile >> $config_mak
2257 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
2258 # (which is the lowest architecture level that Clang supports)
2259 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
2260 write_c_skeleton
2261 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
2262 has_z900=$?
2263 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
2264 if [ $has_z900 != 0 ]; then
2265 echo "WARNING: Your compiler does not support the z900!"
2266 echo " The s390-ccw bios will only work with guest CPUs >= z10."
2268 roms="$roms pc-bios/s390-ccw"
2269 config_mak=pc-bios/s390-ccw/config-host.mak
2270 echo "# Automatically generated by configure - do not modify" > $config_mak
2271 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
2272 write_target_makefile >> $config_mak
2273 # SLOF is required for building the s390-ccw firmware on s390x,
2274 # since it is using the libnet code from SLOF for network booting.
2275 git_submodules="${git_submodules} roms/SLOF"
2279 #######################################
2280 # generate config-host.mak
2282 if ! (GIT="$git" "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
2283 exit 1
2286 config_host_mak="config-host.mak"
2288 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2289 echo >> $config_host_mak
2291 echo all: >> $config_host_mak
2292 echo "GIT=$git" >> $config_host_mak
2293 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
2294 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
2296 if test "$debug_tcg" = "yes" ; then
2297 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
2299 if test "$mingw32" = "yes" ; then
2300 echo "CONFIG_WIN32=y" >> $config_host_mak
2301 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER-QEMU}" >> $config_host_mak
2302 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO-Linux}" >> $config_host_mak
2303 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION-$(cat "$source_path"/VERSION)}" >> $config_host_mak
2304 else
2305 echo "CONFIG_POSIX=y" >> $config_host_mak
2308 if test "$linux" = "yes" ; then
2309 echo "CONFIG_LINUX=y" >> $config_host_mak
2312 if test "$darwin" = "yes" ; then
2313 echo "CONFIG_DARWIN=y" >> $config_host_mak
2316 if test "$solaris" = "yes" ; then
2317 echo "CONFIG_SOLARIS=y" >> $config_host_mak
2319 if test "$static" = "yes" ; then
2320 echo "CONFIG_STATIC=y" >> $config_host_mak
2322 echo "SRC_PATH=$source_path" >> $config_host_mak
2323 echo "TARGET_DIRS=$target_list" >> $config_host_mak
2324 if test "$modules" = "yes"; then
2325 echo "CONFIG_MODULES=y" >> $config_host_mak
2328 # XXX: suppress that
2329 if [ "$bsd" = "yes" ] ; then
2330 echo "CONFIG_BSD=y" >> $config_host_mak
2333 echo "CONFIG_COROUTINE_BACKEND=$coroutine" >> $config_host_mak
2335 if test "$have_asan_iface_fiber" = "yes" ; then
2336 echo "CONFIG_ASAN_IFACE_FIBER=y" >> $config_host_mak
2339 if test "$have_tsan" = "yes" && test "$have_tsan_iface_fiber" = "yes" ; then
2340 echo "CONFIG_TSAN=y" >> $config_host_mak
2343 if test "$plugins" = "yes" ; then
2344 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2347 if test -n "$gdb_bin"; then
2348 gdb_version=$($gdb_bin --version | head -n 1)
2349 if version_ge ${gdb_version##* } 9.1; then
2350 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2351 else
2352 gdb_bin=""
2356 if test "$container" != no; then
2357 echo "ENGINE=$container" >> $config_host_mak
2359 echo "ROMS=$roms" >> $config_host_mak
2360 echo "MAKE=$make" >> $config_host_mak
2361 echo "PYTHON=$python" >> $config_host_mak
2362 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
2363 echo "MESON=$meson" >> $config_host_mak
2364 echo "NINJA=$ninja" >> $config_host_mak
2365 echo "CC=$cc" >> $config_host_mak
2366 echo "QEMU_CFLAGS=$QEMU_CFLAGS" >> $config_host_mak
2367 echo "QEMU_OBJCFLAGS=$QEMU_OBJCFLAGS" >> $config_host_mak
2368 echo "GLIB_CFLAGS=$glib_cflags" >> $config_host_mak
2369 echo "GLIB_LIBS=$glib_libs" >> $config_host_mak
2370 echo "GLIB_BINDIR=$glib_bindir" >> $config_host_mak
2371 echo "GLIB_VERSION=$($pkg_config --modversion glib-2.0)" >> $config_host_mak
2372 echo "QEMU_LDFLAGS=$QEMU_LDFLAGS" >> $config_host_mak
2373 echo "EXESUF=$EXESUF" >> $config_host_mak
2375 # use included Linux headers
2376 if test "$linux" = "yes" ; then
2377 mkdir -p linux-headers
2378 case "$cpu" in
2379 i386|x86_64)
2380 linux_arch=x86
2382 ppc|ppc64)
2383 linux_arch=powerpc
2385 s390x)
2386 linux_arch=s390
2388 aarch64)
2389 linux_arch=arm64
2391 loongarch*)
2392 linux_arch=loongarch
2394 mips64)
2395 linux_arch=mips
2398 # For most CPUs the kernel architecture name and QEMU CPU name match.
2399 linux_arch="$cpu"
2401 esac
2402 # For non-KVM architectures we will not have asm headers
2403 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
2404 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
2408 for target in $target_list; do
2409 target_dir="$target"
2410 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
2411 mkdir -p "$target_dir"
2412 case $target in
2413 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
2414 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
2415 esac
2416 done
2418 if test "$default_targets" = "yes"; then
2419 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
2422 if test "$ccache_cpp2" = "yes"; then
2423 echo "export CCACHE_CPP2=y" >> $config_host_mak
2426 if test "$safe_stack" = "yes"; then
2427 echo "CONFIG_SAFESTACK=y" >> $config_host_mak
2430 # tests/tcg configuration
2431 (config_host_mak=tests/tcg/config-host.mak
2432 mkdir -p tests/tcg
2433 echo "# Automatically generated by configure - do not modify" > $config_host_mak
2434 echo "SRC_PATH=$source_path" >> $config_host_mak
2435 echo "HOST_CC=$host_cc" >> $config_host_mak
2437 # versioned checked in the main config_host.mak above
2438 if test -n "$gdb_bin"; then
2439 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
2441 if test "$plugins" = "yes" ; then
2442 echo "CONFIG_PLUGIN=y" >> $config_host_mak
2445 tcg_tests_targets=
2446 for target in $target_list; do
2447 arch=${target%%-*}
2449 case $target in
2450 xtensa*-linux-user)
2451 # the toolchain is not complete with headers, only build softmmu tests
2452 continue
2454 *-softmmu)
2455 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
2456 qemu="qemu-system-$arch"
2458 *-linux-user|*-bsd-user)
2459 qemu="qemu-$arch"
2461 esac
2463 if probe_target_compiler $target || test -n "$container_image"; then
2464 test -n "$container_image" && build_static=y
2465 mkdir -p "tests/tcg/$target"
2466 config_target_mak=tests/tcg/$target/config-target.mak
2467 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
2468 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
2469 echo "TARGET_NAME=$arch" >> "$config_target_mak"
2470 echo "TARGET=$target" >> "$config_target_mak"
2471 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
2472 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
2473 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
2474 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
2475 tcg_tests_targets="$tcg_tests_targets $target"
2477 done
2479 if test "$tcg" = "enabled"; then
2480 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak
2484 if test "$skip_meson" = no; then
2485 cross="config-meson.cross.new"
2486 meson_quote() {
2487 test $# = 0 && return
2488 echo "'$(echo $* | sed "s/ /','/g")'"
2491 echo "# Automatically generated by configure - do not modify" > $cross
2492 echo "[properties]" >> $cross
2494 # unroll any custom device configs
2495 for a in $device_archs; do
2496 eval "c=\$devices_${a}"
2497 echo "${a}-softmmu = '$c'" >> $cross
2498 done
2500 echo "[built-in options]" >> $cross
2501 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
2502 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
2503 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
2504 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
2505 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
2506 echo "[binaries]" >> $cross
2507 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
2508 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
2509 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
2510 echo "ar = [$(meson_quote $ar)]" >> $cross
2511 echo "nm = [$(meson_quote $nm)]" >> $cross
2512 echo "pkgconfig = [$(meson_quote $pkg_config_exe)]" >> $cross
2513 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
2514 if has $sdl2_config; then
2515 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
2517 echo "strip = [$(meson_quote $strip)]" >> $cross
2518 echo "widl = [$(meson_quote $widl)]" >> $cross
2519 echo "windres = [$(meson_quote $windres)]" >> $cross
2520 echo "windmc = [$(meson_quote $windmc)]" >> $cross
2521 if test "$cross_compile" = "yes"; then
2522 cross_arg="--cross-file config-meson.cross"
2523 echo "[host_machine]" >> $cross
2524 echo "system = '$targetos'" >> $cross
2525 case "$cpu" in
2526 i386)
2527 echo "cpu_family = 'x86'" >> $cross
2530 echo "cpu_family = '$cpu'" >> $cross
2532 esac
2533 echo "cpu = '$cpu'" >> $cross
2534 if test "$bigendian" = "yes" ; then
2535 echo "endian = 'big'" >> $cross
2536 else
2537 echo "endian = 'little'" >> $cross
2539 else
2540 cross_arg="--native-file config-meson.cross"
2542 mv $cross config-meson.cross
2544 rm -rf meson-private meson-info meson-logs
2546 # Built-in options
2547 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
2548 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
2549 test "$pie" = no && meson_option_add -Db_pie=false
2550 test "$werror" = yes && meson_option_add -Dwerror=true
2552 # QEMU options
2553 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
2554 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
2555 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
2556 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
2557 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
2558 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
2559 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
2560 run_meson() {
2561 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
2563 eval run_meson $meson_options
2564 if test "$?" -ne 0 ; then
2565 error_exit "meson setup failed"
2569 # Save the configure command line for later reuse.
2570 cat <<EOD >config.status
2571 #!/bin/sh
2572 # Generated by configure.
2573 # Run this file to recreate the current configuration.
2574 # Compiler output produced by configure, useful for debugging
2575 # configure, is in config.log if it exists.
2578 preserve_env() {
2579 envname=$1
2581 eval envval=\$$envname
2583 if test -n "$envval"
2584 then
2585 echo "$envname='$envval'" >> config.status
2586 echo "export $envname" >> config.status
2587 else
2588 echo "unset $envname" >> config.status
2592 # Preserve various env variables that influence what
2593 # features/build target configure will detect
2594 preserve_env AR
2595 preserve_env AS
2596 preserve_env CC
2597 preserve_env CFLAGS
2598 preserve_env CXX
2599 preserve_env CXXFLAGS
2600 preserve_env LD
2601 preserve_env LDFLAGS
2602 preserve_env LD_LIBRARY_PATH
2603 preserve_env MAKE
2604 preserve_env NM
2605 preserve_env OBJCFLAGS
2606 preserve_env OBJCOPY
2607 preserve_env PATH
2608 preserve_env PKG_CONFIG
2609 preserve_env PKG_CONFIG_LIBDIR
2610 preserve_env PKG_CONFIG_PATH
2611 preserve_env PYTHON
2612 preserve_env QEMU_GA_MANUFACTURER
2613 preserve_env QEMU_GA_DISTRO
2614 preserve_env QEMU_GA_VERSION
2615 preserve_env SDL2_CONFIG
2616 preserve_env SMBD
2617 preserve_env STRIP
2618 preserve_env WIDL
2619 preserve_env WINDRES
2620 preserve_env WINDMC
2622 printf "exec" >>config.status
2623 for i in "$0" "$@"; do
2624 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2625 done
2626 echo ' "$@"' >>config.status
2627 chmod +x config.status
2629 rm -r "$TMPDIR1"